processing.opengl

## Class PJOGL

- java.lang.Object
- - processing.opengl.PGL
  - - processing.opengl.PJOGL

-     public class PJOGL
      extends PGL

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `AWT`
    `Canvas` | `canvas` The canvas where OpenGL rendering takes place
    `com.jogamp.opengl.GLContext` | `context` The rendering context (holds rendering state info)
    `com.jogamp.opengl.GL` | `gl` Basic GL functionality, common to all profiles
    `com.jogamp.opengl.glu.GLU` | `glu` GLU interface
    `static int` | `NEWT`
    `static com.jogamp.opengl.GLProfile` | `profile` Selected GL profile
    `static int` | `PROFILE`
    `static boolean` | `RETINA`

    - ### Fields inherited from class processing.opengl.PGL

      `ALIASED_LINE_WIDTH_RANGE, ALIASED_POINT_SIZE_RANGE, ALPHA, ALPHA_TEST, ALPHA8, ALWAYS, ARRAY_BUFFER, BACK, BLEND, BOOL, BOOL_VEC2, BOOL_VEC3, BOOL_VEC4, BUFFER_SIZE, BUFFER_USAGE, BYTE, CCW, CLAMP_TO_EDGE, COLOR_ATTACHMENT0, COLOR_ATTACHMENT1, COLOR_ATTACHMENT2, COLOR_ATTACHMENT3, COLOR_BUFFER_BIT, COMPILE_STATUS, COMPRESSED_TEXTURE_FORMATS, CONSTANT_ALPHA, CONSTANT_COLOR, CULL_FACE, CURRENT_VERTEX_ATTRIB, CW, DECR, DECR_WRAP, DELETE_STATUS, DEPTH_ATTACHMENT, DEPTH_BITS, DEPTH_BUFFER_BIT, DEPTH_COMPONENT, DEPTH_COMPONENT16, DEPTH_COMPONENT24, DEPTH_COMPONENT32, DEPTH_STENCIL, DEPTH_TEST, DEPTH_WRITEMASK, DEPTH24_STENCIL8, DITHER, DONT_CARE, DRAW_FRAMEBUFFER, DST_ALPHA, DST_COLOR, DYNAMIC_DRAW, ELEMENT_ARRAY_BUFFER, EQUAL, EXTENSIONS, FALSE, FASTEST, FLOAT, FLOAT_MAT2, FLOAT_MAT3, FLOAT_MAT4, FLOAT_VEC2, FLOAT_VEC3, FLOAT_VEC4, FRAGMENT_SHADER, FRAMEBUFFER, FRAMEBUFFER_ATTACHMENT_OBJECT_NAME, FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE, FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE, FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL, FRAMEBUFFER_COMPLETE, FRAMEBUFFER_ERROR, FRAMEBUFFER_INCOMPLETE_ATTACHMENT, FRAMEBUFFER_INCOMPLETE_DIMENSIONS, FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER, FRAMEBUFFER_INCOMPLETE_FORMATS, FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT, FRAMEBUFFER_INCOMPLETE_READ_BUFFER, FRAMEBUFFER_UNSUPPORTED, FRONT, FRONT_AND_BACK, FUNC_ADD, FUNC_MAX, FUNC_MIN, FUNC_REVERSE_SUBTRACT, FUNC_SUBTRACT, GENERATE_MIPMAP_HINT, GEQUAL, GREATER, HIGH_FLOAT, HIGH_INT, INCR, INCR_WRAP, INFO_LOG_LENGTH, INT, INT_VEC2, INT_VEC3, INT_VEC4, INVERT, KEEP, LEQUAL, LESS, LINE_LOOP, LINE_SMOOTH, LINE_STRIP, LINEAR, LINEAR_MIPMAP_LINEAR, LINEAR_MIPMAP_NEAREST, LINES, LINK_STATUS, LOW_FLOAT, LOW_INT, LUMINANCE, LUMINANCE_ALPHA, MAX_COMBINED_TEXTURE_IMAGE_UNITS, MAX_SAMPLES, MAX_TEXTURE_IMAGE_UNITS, MAX_TEXTURE_MAX_ANISOTROPY, MAX_TEXTURE_SIZE, MAX_VERTEX_ATTRIBS, MAX_VERTEX_TEXTURE_IMAGE_UNITS, MEDIUM_FLOAT, MEDIUM_INT, MISSING_FBO_ERROR, MISSING_GLFUNC_ERROR, MISSING_GLSL_ERROR, MULTISAMPLE, NEAREST, NEVER, NICEST, NONPRIMARY_ERROR, NOTEQUAL, NUM_COMPRESSED_TEXTURE_FORMATS, offsetX, offsetY, ONE, ONE_MINUS_CONSTANT_ALPHA, ONE_MINUS_CONSTANT_COLOR, ONE_MINUS_DST_COLOR, ONE_MINUS_SRC_ALPHA, ONE_MINUS_SRC_COLOR, PACK_ALIGNMENT, POINT_SMOOTH, POINTS, POLYGON_OFFSET_FILL, POLYGON_SMOOTH, presentMode, primaryPGL, READ_FRAMEBUFFER, READ_ONLY, READ_WRITE, RENDERBUFFER, RENDERBUFFER_ALPHA_SIZE, RENDERBUFFER_BLUE_SIZE, RENDERBUFFER_DEPTH_SIZE, RENDERBUFFER_GREEN_SIZE, RENDERBUFFER_HEIGHT, RENDERBUFFER_INTERNAL_FORMAT, RENDERBUFFER_RED_SIZE, RENDERBUFFER_STENCIL_SIZE, RENDERBUFFER_WIDTH, RENDERER, REPEAT, REPLACE, reqNumSamples, REQUESTED_ALPHA_BITS, REQUESTED_DEPTH_BITS, REQUESTED_STENCIL_BITS, RGB, RGB5_A1, RGB565, RGB8, RGBA, RGBA4, RGBA8, SAMPLE_ALPHA_TO_COVERAGE, SAMPLE_COVERAGE, SAMPLER_2D, SAMPLER_CUBE, SAMPLES, SCISSOR_TEST, SHADER_SOURCE_LENGTH, SHADER_TYPE, SHADING_LANGUAGE_VERSION, SHORT, SRC_ALPHA, SRC_ALPHA_SATURATE, SRC_COLOR, STATIC_DRAW, STENCIL_ATTACHMENT, STENCIL_BITS, STENCIL_BUFFER_BIT, STENCIL_INDEX, STENCIL_INDEX1, STENCIL_INDEX4, STENCIL_INDEX8, STENCIL_TEST, STREAM_DRAW, TESS_WINDING_NONZERO, TESS_WINDING_ODD, TEXTURE_2D, TEXTURE_BINDING_2D, TEXTURE_BINDING_RECTANGLE, TEXTURE_CUBE_MAP, TEXTURE_CUBE_MAP_NEGATIVE_X, TEXTURE_CUBE_MAP_NEGATIVE_Y, TEXTURE_CUBE_MAP_NEGATIVE_Z, TEXTURE_CUBE_MAP_POSITIVE_X, TEXTURE_CUBE_MAP_POSITIVE_Y, TEXTURE_CUBE_MAP_POSITIVE_Z, TEXTURE_MAG_FILTER, TEXTURE_MAX_ANISOTROPY, TEXTURE_MIN_FILTER, TEXTURE_RECTANGLE, TEXTURE_WRAP_R, TEXTURE_WRAP_S, TEXTURE_WRAP_T, TEXTURE0, TEXTURE1, TEXTURE2, TEXTURE3, TEXUNIT_ERROR, TRIANGLE_FAN, TRIANGLE_STRIP, TRIANGLES, TRUE, UNPACK_ALIGNMENT, UNSIGNED_BYTE, UNSIGNED_INT, UNSIGNED_SHORT, UNSIGNED_SHORT_4_4_4_4, UNSIGNED_SHORT_5_5_5_1, UNSIGNED_SHORT_5_6_5, UNSUPPORTED_GLPROF_ERROR, VALIDATE_STATUS, VENDOR, VERSION, VERTEX_ATTRIB_ARRAY_BUFFER_BINDING, VERTEX_ATTRIB_ARRAY_ENABLED, VERTEX_ATTRIB_ARRAY_NORMALIZED, VERTEX_ATTRIB_ARRAY_POINTER, VERTEX_ATTRIB_ARRAY_SIZE, VERTEX_ATTRIB_ARRAY_STRIDE, VERTEX_ATTRIB_ARRAY_TYPE, VERTEX_SHADER, VIEWPORT, WIKI, WRITE_ONLY, ZERO`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PJOGL(PGraphicsOpenGL pg)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `alphaFunc(int func, float ref)`
    `void` | `attachShader(int program, int shader)`
    `void` | `bindAttribLocation(int program, int index, String name)`
    `void` | `bindBuffer(int target, int buffer)`
    `void` | `bindRenderbuffer(int target, int renderbuffer)`
    `void` | `blendColor(float red, float green, float blue, float alpha)`
    `void` | `blendEquation(int mode)`
    `void` | `blendEquationSeparate(int modeRGB, int modeAlpha)`
    `void` | `blendFunc(int src, int dst)`
    `void` | `blendFuncSeparate(int srcRGB, int dstRGB, int srcAlpha, int dstAlpha)`
    `void` | `blitFramebuffer(int srcX0, int srcY0, int srcX1, int srcY1, int dstX0, int dstY0, int dstX1, int dstY1, int mask, int filter)`
    `void` | `bufferData(int target, int size, Buffer data, int usage)`
    `void` | `bufferSubData(int target, int offset, int size, Buffer data)`
    `int` | `checkFramebufferStatus(int target)`
    `void` | `clear(int buf)`
    `void` | `clearColor(float r, float g, float b, float a)`
    `void` | `clearDepth(float d)`
    `void` | `clearStencil(int s)`
    `void` | `colorMask(boolean r, boolean g, boolean b, boolean a)`
    `void` | `compileShader(int shader)`
    `void` | `compressedTexImage2D(int target, int level, int internalFormat, int width, int height, int border, int imageSize, Buffer data)`
    `void` | `compressedTexSubImage2D(int target, int level, int xOffset, int yOffset, int width, int height, int format, int imageSize, Buffer data)`
    `void` | `copyTexImage2D(int target, int level, int internalFormat, int x, int y, int width, int height, int border)`
    `void` | `copyTexSubImage2D(int target, int level, int xOffset, int yOffset, int x, int y, int width, int height)`
    `int` | `createProgram()`
    `int` | `createShader(int type)`
    `void` | `cullFace(int mode)`
    `void` | `deleteBuffers(int n, IntBuffer buffers)`
    `void` | `deleteFramebuffers(int n, IntBuffer framebuffers)`
    `void` | `deleteProgram(int program)`
    `void` | `deleteRenderbuffers(int n, IntBuffer renderbuffers)`
    `void` | `deleteShader(int shader)`
    `void` | `deleteTextures(int n, IntBuffer textures)`
    `void` | `depthFunc(int func)`
    `void` | `depthMask(boolean mask)`
    `void` | `depthRangef(float n, float f)`
    `void` | `detachShader(int program, int shader)`
    `void` | `disable(int value)`
    `void` | `disableVertexAttribArray(int index)`
    `void` | `drawArrays(int mode, int first, int count)`
    `void` | `drawBuffer(int buf)`
    `void` | `drawElements(int mode, int count, int type, Buffer indices)`
    `void` | `drawElements(int mode, int count, int type, int offset)`
    `void` | `enable(int value)`
    `void` | `enableVertexAttribArray(int index)`
    `String` | `errorString(int err)`
    `void` | `finish()`
    `void` | `flush()`
    `void` | `framebufferRenderbuffer(int target, int attachment, int rendbuferfTarget, int renderbuffer)`
    `void` | `framebufferTexture2D(int target, int attachment, int texTarget, int texture, int level)`
    `void` | `frontFace(int dir)`
    `void` | `genBuffers(int n, IntBuffer buffers)`
    `void` | `generateMipmap(int target)`
    `void` | `genFramebuffers(int n, IntBuffer framebuffers)`
    `void` | `genRenderbuffers(int n, IntBuffer renderbuffers)`
    `void` | `genTextures(int n, IntBuffer textures)`
    `String` | `getActiveAttrib(int program, int index, IntBuffer size, IntBuffer type)`
    `String` | `getActiveUniform(int program, int index, IntBuffer size, IntBuffer type)`
    `void` | `getAttachedShaders(int program, int maxCount, IntBuffer count, IntBuffer shaders)`
    `int` | `getAttribLocation(int program, String name)`
    `void` | `getBooleanv(int value, IntBuffer data)`
    `void` | `getBufferParameteriv(int target, int value, IntBuffer data)`
    `int` | `getError()`
    `void` | `getFloatv(int value, FloatBuffer data)`
    `void` | `getFramebufferAttachmentParameteriv(int target, int attachment, int pname, IntBuffer params)`
    `void` | `getIntegerv(int value, IntBuffer data)`
    `String` | `getProgramInfoLog(int program)`
    `void` | `getProgramiv(int program, int pname, IntBuffer params)`
    `void` | `getRenderbufferParameteriv(int target, int pname, IntBuffer params)`
    `String` | `getShaderInfoLog(int shader)`
    `void` | `getShaderiv(int shader, int pname, IntBuffer params)`
    `void` | `getShaderPrecisionFormat(int shaderType, int precisionType, IntBuffer range, IntBuffer precision)`
    `String` | `getShaderSource(int shader)`
    `String` | `getString(int name)`
    `void` | `getTexParameterfv(int target, int pname, FloatBuffer params)`
    `void` | `getTexParameteriv(int target, int pname, IntBuffer params)`
    `void` | `getUniformfv(int program, int location, FloatBuffer params)`
    `void` | `getUniformiv(int program, int location, IntBuffer params)`
    `int` | `getUniformLocation(int program, String name)`
    `void` | `getVertexAttribfv(int index, int pname, FloatBuffer params)`
    `void` | `getVertexAttribiv(int index, int pname, IntBuffer params)`
    `void` | `getVertexAttribPointerv(int index, int pname, ByteBuffer data)`
    `void` | `hint(int target, int hint)`
    `void` | `isBuffer(int buffer)`
    `boolean` | `isEnabled(int value)`
    `boolean` | `isFramebuffer(int framebuffer)`
    `boolean` | `isProgram(int program)`
    `boolean` | `isRenderbuffer(int renderbuffer)`
    `boolean` | `isShader(int shader)`
    `boolean` | `isTexture(int texture)`
    `void` | `lineWidth(float width)`
    `void` | `linkProgram(int program)`
    `ByteBuffer` | `mapBuffer(int target, int access)`
    `ByteBuffer` | `mapBufferRange(int target, int offset, int length, int access)`
    `void` | `pixelStorei(int pname, int param)`
    `void` | `polygonOffset(float factor, float units)`
    `void` | `readBuffer(int buf)`
    `void` | `releaseShaderCompiler()`
    `void` | `renderbufferStorage(int target, int internalFormat, int width, int height)`
    `void` | `renderbufferStorageMultisample(int target, int samples, int format, int width, int height)`
    `void` | `sampleCoverage(float value, boolean invert)`
    `void` | `scissor(int x, int y, int w, int h)`
    `void` | `shaderBinary(int count, IntBuffer shaders, int binaryFormat, Buffer binary, int length)`
    `void` | `shaderSource(int shader, String source)`
    `void` | `stencilFunc(int func, int ref, int mask)`
    `void` | `stencilFuncSeparate(int face, int func, int ref, int mask)`
    `void` | `stencilMask(int mask)`
    `void` | `stencilMaskSeparate(int face, int mask)`
    `void` | `stencilOp(int sfail, int dpfail, int dppass)`
    `void` | `stencilOpSeparate(int face, int sfail, int dpfail, int dppass)`
    `void` | `texImage2D(int target, int level, int internalFormat, int width, int height, int border, int format, int type, Buffer data)`
    `void` | `texParameterf(int target, int pname, float param)`
    `void` | `texParameterfv(int target, int pname, FloatBuffer params)`
    `void` | `texParameteri(int target, int pname, int param)`
    `void` | `texParameteriv(int target, int pname, IntBuffer params)`
    `void` | `texSubImage2D(int target, int level, int xOffset, int yOffset, int width, int height, int format, int type, Buffer data)`
    `void` | `uniform1f(int location, float value)`
    `void` | `uniform1fv(int location, int count, FloatBuffer v)`
    `void` | `uniform1i(int location, int value)`
    `void` | `uniform1iv(int location, int count, IntBuffer v)`
    `void` | `uniform2f(int location, float value0, float value1)`
    `void` | `uniform2fv(int location, int count, FloatBuffer v)`
    `void` | `uniform2i(int location, int value0, int value1)`
    `void` | `uniform2iv(int location, int count, IntBuffer v)`
    `void` | `uniform3f(int location, float value0, float value1, float value2)`
    `void` | `uniform3fv(int location, int count, FloatBuffer v)`
    `void` | `uniform3i(int location, int value0, int value1, int value2)`
    `void` | `uniform3iv(int location, int count, IntBuffer v)`
    `void` | `uniform4f(int location, float value0, float value1, float value2, float value3)`
    `void` | `uniform4fv(int location, int count, FloatBuffer v)`
    `void` | `uniform4i(int location, int value0, int value1, int value2, int value3)`
    `void` | `uniform4iv(int location, int count, IntBuffer v)`
    `void` | `uniformMatrix2fv(int location, int count, boolean transpose, FloatBuffer mat)`
    `void` | `uniformMatrix3fv(int location, int count, boolean transpose, FloatBuffer mat)`
    `void` | `uniformMatrix4fv(int location, int count, boolean transpose, FloatBuffer mat)`
    `void` | `unmapBuffer(int target)`
    `void` | `useProgram(int program)`
    `void` | `validateProgram(int program)`
    `void` | `vertexAttri4fv(int index, FloatBuffer values)`
    `void` | `vertexAttrib1f(int index, float value)`
    `void` | `vertexAttrib1fv(int index, FloatBuffer values)`
    `void` | `vertexAttrib2f(int index, float value0, float value1)`
    `void` | `vertexAttrib2fv(int index, FloatBuffer values)`
    `void` | `vertexAttrib3f(int index, float value0, float value1, float value2)`
    `void` | `vertexAttrib3fv(int index, FloatBuffer values)`
    `void` | `vertexAttrib4f(int index, float value0, float value1, float value2, float value3)`
    `void` | `vertexAttribPointer(int index, int size, int type, boolean normalized, int stride, Buffer data)`
    `void` | `vertexAttribPointer(int index, int size, int type, boolean normalized, int stride, int offset)`
    `void` | `viewport(int x, int y, int w, int h)`

    - ### Methods inherited from class processing.opengl.PGL

      `activeTexture, bindFramebuffer, bindTexture, drawTexture, drawTexture, readPixels, requestFBOLayer, setPrimary, setThread, threadIsCurrent`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### PROFILE

          public static int PROFILE

    - #### RETINA

          public static boolean RETINA

    - #### AWT

          public static final int AWT

      See Also:
        Constant Field Values

    - #### NEWT

          public static final int NEWT

      See Also:
        Constant Field Values

    - #### gl

          public com.jogamp.opengl.GL gl

      Basic GL functionality, common to all profiles

    - #### glu

          public com.jogamp.opengl.glu.GLU glu

      GLU interface

    - #### context

          public com.jogamp.opengl.GLContext context

      The rendering context (holds rendering state info)

    - #### canvas

          public Canvas canvas

      The canvas where OpenGL rendering takes place

    - #### profile

          public static com.jogamp.opengl.GLProfile profile

      Selected GL profile

  - ### Constructor Detail

    - #### PJOGL

          public PJOGL(PGraphicsOpenGL pg)

  - ### Method Detail

    - #### flush

          public void flush()

      Specified by:
        `flush` in class `PGL`

    - #### finish

          public void finish()

      Specified by:
        `finish` in class `PGL`

    - #### hint

          public void hint(int target,
                           int hint)

      Specified by:
        `hint` in class `PGL`

    - #### enable

          public void enable(int value)

      Specified by:
        `enable` in class `PGL`

    - #### disable

          public void disable(int value)

      Specified by:
        `disable` in class `PGL`

    - #### getBooleanv

          public void getBooleanv(int value,
                                  IntBuffer data)

      Specified by:
        `getBooleanv` in class `PGL`

    - #### getIntegerv

          public void getIntegerv(int value,
                                  IntBuffer data)

      Specified by:
        `getIntegerv` in class `PGL`

    - #### getFloatv

          public void getFloatv(int value,
                                FloatBuffer data)

      Specified by:
        `getFloatv` in class `PGL`

    - #### isEnabled

          public boolean isEnabled(int value)

      Specified by:
        `isEnabled` in class `PGL`

    - #### getString

          public String getString(int name)

      Specified by:
        `getString` in class `PGL`

    - #### getError

          public int getError()

      Specified by:
        `getError` in class `PGL`

    - #### errorString

          public String errorString(int err)

      Specified by:
        `errorString` in class `PGL`

    - #### genBuffers

          public void genBuffers(int n,
                                 IntBuffer buffers)

      Specified by:
        `genBuffers` in class `PGL`

    - #### deleteBuffers

          public void deleteBuffers(int n,
                                    IntBuffer buffers)

      Specified by:
        `deleteBuffers` in class `PGL`

    - #### bindBuffer

          public void bindBuffer(int target,
                                 int buffer)

      Specified by:
        `bindBuffer` in class `PGL`

    - #### bufferData

          public void bufferData(int target,
                                 int size,
                                 Buffer data,
                                 int usage)

      Specified by:
        `bufferData` in class `PGL`

    - #### bufferSubData

          public void bufferSubData(int target,
                                    int offset,
                                    int size,
                                    Buffer data)

      Specified by:
        `bufferSubData` in class `PGL`

    - #### isBuffer

          public void isBuffer(int buffer)

      Specified by:
        `isBuffer` in class `PGL`

    - #### getBufferParameteriv

          public void getBufferParameteriv(int target,
                                           int value,
                                           IntBuffer data)

      Specified by:
        `getBufferParameteriv` in class `PGL`

    - #### mapBuffer

          public ByteBuffer mapBuffer(int target,
                                      int access)

      Specified by:
        `mapBuffer` in class `PGL`

    - #### mapBufferRange

          public ByteBuffer mapBufferRange(int target,
                                           int offset,
                                           int length,
                                           int access)

      Specified by:
        `mapBufferRange` in class `PGL`

    - #### unmapBuffer

          public void unmapBuffer(int target)

      Specified by:
        `unmapBuffer` in class `PGL`

    - #### depthRangef

          public void depthRangef(float n,
                                  float f)

      Specified by:
        `depthRangef` in class `PGL`

    - #### viewport

          public void viewport(int x,
                               int y,
                               int w,
                               int h)

      Specified by:
        `viewport` in class `PGL`

    - #### vertexAttrib1f

          public void vertexAttrib1f(int index,
                                     float value)

      Specified by:
        `vertexAttrib1f` in class `PGL`

    - #### vertexAttrib2f

          public void vertexAttrib2f(int index,
                                     float value0,
                                     float value1)

      Specified by:
        `vertexAttrib2f` in class `PGL`

    - #### vertexAttrib3f

          public void vertexAttrib3f(int index,
                                     float value0,
                                     float value1,
                                     float value2)

      Specified by:
        `vertexAttrib3f` in class `PGL`

    - #### vertexAttrib4f

          public void vertexAttrib4f(int index,
                                     float value0,
                                     float value1,
                                     float value2,
                                     float value3)

      Specified by:
        `vertexAttrib4f` in class `PGL`

    - #### vertexAttrib1fv

          public void vertexAttrib1fv(int index,
                                      FloatBuffer values)

      Specified by:
        `vertexAttrib1fv` in class `PGL`

    - #### vertexAttrib2fv

          public void vertexAttrib2fv(int index,
                                      FloatBuffer values)

      Specified by:
        `vertexAttrib2fv` in class `PGL`

    - #### vertexAttrib3fv

          public void vertexAttrib3fv(int index,
                                      FloatBuffer values)

      Specified by:
        `vertexAttrib3fv` in class `PGL`

    - #### vertexAttri4fv

          public void vertexAttri4fv(int index,
                                     FloatBuffer values)

      Specified by:
        `vertexAttri4fv` in class `PGL`

    - #### vertexAttribPointer

          public void vertexAttribPointer(int index,
                                          int size,
                                          int type,
                                          boolean normalized,
                                          int stride,
                                          int offset)

      Specified by:
        `vertexAttribPointer` in class `PGL`

    - #### vertexAttribPointer

          public void vertexAttribPointer(int index,
                                          int size,
                                          int type,
                                          boolean normalized,
                                          int stride,
                                          Buffer data)

      Specified by:
        `vertexAttribPointer` in class `PGL`

    - #### enableVertexAttribArray

          public void enableVertexAttribArray(int index)

      Specified by:
        `enableVertexAttribArray` in class `PGL`

    - #### disableVertexAttribArray

          public void disableVertexAttribArray(int index)

      Specified by:
        `disableVertexAttribArray` in class `PGL`

    - #### drawArrays

          public void drawArrays(int mode,
                                 int first,
                                 int count)

      Specified by:
        `drawArrays` in class `PGL`

    - #### drawElements

          public void drawElements(int mode,
                                   int count,
                                   int type,
                                   int offset)

      Specified by:
        `drawElements` in class `PGL`

    - #### drawElements

          public void drawElements(int mode,
                                   int count,
                                   int type,
                                   Buffer indices)

      Specified by:
        `drawElements` in class `PGL`

    - #### lineWidth

          public void lineWidth(float width)

      Specified by:
        `lineWidth` in class `PGL`

    - #### frontFace

          public void frontFace(int dir)

      Specified by:
        `frontFace` in class `PGL`

    - #### cullFace

          public void cullFace(int mode)

      Specified by:
        `cullFace` in class `PGL`

    - #### polygonOffset

          public void polygonOffset(float factor,
                                    float units)

      Specified by:
        `polygonOffset` in class `PGL`

    - #### pixelStorei

          public void pixelStorei(int pname,
                                  int param)

      Specified by:
        `pixelStorei` in class `PGL`

    - #### texImage2D

          public void texImage2D(int target,
                                 int level,
                                 int internalFormat,
                                 int width,
                                 int height,
                                 int border,
                                 int format,
                                 int type,
                                 Buffer data)

      Specified by:
        `texImage2D` in class `PGL`

    - #### copyTexImage2D

          public void copyTexImage2D(int target,
                                     int level,
                                     int internalFormat,
                                     int x,
                                     int y,
                                     int width,
                                     int height,
                                     int border)

      Specified by:
        `copyTexImage2D` in class `PGL`

    - #### texSubImage2D

          public void texSubImage2D(int target,
                                    int level,
                                    int xOffset,
                                    int yOffset,
                                    int width,
                                    int height,
                                    int format,
                                    int type,
                                    Buffer data)

      Specified by:
        `texSubImage2D` in class `PGL`

    - #### copyTexSubImage2D

          public void copyTexSubImage2D(int target,
                                        int level,
                                        int xOffset,
                                        int yOffset,
                                        int x,
                                        int y,
                                        int width,
                                        int height)

      Specified by:
        `copyTexSubImage2D` in class `PGL`

    - #### compressedTexImage2D

          public void compressedTexImage2D(int target,
                                           int level,
                                           int internalFormat,
                                           int width,
                                           int height,
                                           int border,
                                           int imageSize,
                                           Buffer data)

      Specified by:
        `compressedTexImage2D` in class `PGL`

    - #### compressedTexSubImage2D

          public void compressedTexSubImage2D(int target,
                                              int level,
                                              int xOffset,
                                              int yOffset,
                                              int width,
                                              int height,
                                              int format,
                                              int imageSize,
                                              Buffer data)

      Specified by:
        `compressedTexSubImage2D` in class `PGL`

    - #### texParameteri

          public void texParameteri(int target,
                                    int pname,
                                    int param)

      Specified by:
        `texParameteri` in class `PGL`

    - #### texParameterf

          public void texParameterf(int target,
                                    int pname,
                                    float param)

      Specified by:
        `texParameterf` in class `PGL`

    - #### texParameteriv

          public void texParameteriv(int target,
                                     int pname,
                                     IntBuffer params)

      Specified by:
        `texParameteriv` in class `PGL`

    - #### texParameterfv

          public void texParameterfv(int target,
                                     int pname,
                                     FloatBuffer params)

      Specified by:
        `texParameterfv` in class `PGL`

    - #### generateMipmap

          public void generateMipmap(int target)

      Specified by:
        `generateMipmap` in class `PGL`

    - #### genTextures

          public void genTextures(int n,
                                  IntBuffer textures)

      Specified by:
        `genTextures` in class `PGL`

    - #### deleteTextures

          public void deleteTextures(int n,
                                     IntBuffer textures)

      Specified by:
        `deleteTextures` in class `PGL`

    - #### getTexParameteriv

          public void getTexParameteriv(int target,
                                        int pname,
                                        IntBuffer params)

      Specified by:
        `getTexParameteriv` in class `PGL`

    - #### getTexParameterfv

          public void getTexParameterfv(int target,
                                        int pname,
                                        FloatBuffer params)

      Specified by:
        `getTexParameterfv` in class `PGL`

    - #### isTexture

          public boolean isTexture(int texture)

      Specified by:
        `isTexture` in class `PGL`

    - #### createShader

          public int createShader(int type)

      Specified by:
        `createShader` in class `PGL`

    - #### shaderSource

          public void shaderSource(int shader,
                                   String source)

      Specified by:
        `shaderSource` in class `PGL`

    - #### compileShader

          public void compileShader(int shader)

      Specified by:
        `compileShader` in class `PGL`

    - #### releaseShaderCompiler

          public void releaseShaderCompiler()

      Specified by:
        `releaseShaderCompiler` in class `PGL`

    - #### deleteShader

          public void deleteShader(int shader)

      Specified by:
        `deleteShader` in class `PGL`

    - #### shaderBinary

          public void shaderBinary(int count,
                                   IntBuffer shaders,
                                   int binaryFormat,
                                   Buffer binary,
                                   int length)

      Specified by:
        `shaderBinary` in class `PGL`

    - #### createProgram

          public int createProgram()

      Specified by:
        `createProgram` in class `PGL`

    - #### attachShader

          public void attachShader(int program,
                                   int shader)

      Specified by:
        `attachShader` in class `PGL`

    - #### detachShader

          public void detachShader(int program,
                                   int shader)

      Specified by:
        `detachShader` in class `PGL`

    - #### linkProgram

          public void linkProgram(int program)

      Specified by:
        `linkProgram` in class `PGL`

    - #### useProgram

          public void useProgram(int program)

      Specified by:
        `useProgram` in class `PGL`

    - #### deleteProgram

          public void deleteProgram(int program)

      Specified by:
        `deleteProgram` in class `PGL`

    - #### getActiveAttrib

          public String getActiveAttrib(int program,
                                        int index,
                                        IntBuffer size,
                                        IntBuffer type)

      Specified by:
        `getActiveAttrib` in class `PGL`

    - #### getAttribLocation

          public int getAttribLocation(int program,
                                       String name)

      Specified by:
        `getAttribLocation` in class `PGL`

    - #### bindAttribLocation

          public void bindAttribLocation(int program,
                                         int index,
                                         String name)

      Specified by:
        `bindAttribLocation` in class `PGL`

    - #### getUniformLocation

          public int getUniformLocation(int program,
                                        String name)

      Specified by:
        `getUniformLocation` in class `PGL`

    - #### getActiveUniform

          public String getActiveUniform(int program,
                                         int index,
                                         IntBuffer size,
                                         IntBuffer type)

      Specified by:
        `getActiveUniform` in class `PGL`

    - #### uniform1i

          public void uniform1i(int location,
                                int value)

      Specified by:
        `uniform1i` in class `PGL`

    - #### uniform2i

          public void uniform2i(int location,
                                int value0,
                                int value1)

      Specified by:
        `uniform2i` in class `PGL`

    - #### uniform3i

          public void uniform3i(int location,
                                int value0,
                                int value1,
                                int value2)

      Specified by:
        `uniform3i` in class `PGL`

    - #### uniform4i

          public void uniform4i(int location,
                                int value0,
                                int value1,
                                int value2,
                                int value3)

      Specified by:
        `uniform4i` in class `PGL`

    - #### uniform1f

          public void uniform1f(int location,
                                float value)

      Specified by:
        `uniform1f` in class `PGL`

    - #### uniform2f

          public void uniform2f(int location,
                                float value0,
                                float value1)

      Specified by:
        `uniform2f` in class `PGL`

    - #### uniform3f

          public void uniform3f(int location,
                                float value0,
                                float value1,
                                float value2)

      Specified by:
        `uniform3f` in class `PGL`

    - #### uniform4f

          public void uniform4f(int location,
                                float value0,
                                float value1,
                                float value2,
                                float value3)

      Specified by:
        `uniform4f` in class `PGL`

    - #### uniform1iv

          public void uniform1iv(int location,
                                 int count,
                                 IntBuffer v)

      Specified by:
        `uniform1iv` in class `PGL`

    - #### uniform2iv

          public void uniform2iv(int location,
                                 int count,
                                 IntBuffer v)

      Specified by:
        `uniform2iv` in class `PGL`

    - #### uniform3iv

          public void uniform3iv(int location,
                                 int count,
                                 IntBuffer v)

      Specified by:
        `uniform3iv` in class `PGL`

    - #### uniform4iv

          public void uniform4iv(int location,
                                 int count,
                                 IntBuffer v)

      Specified by:
        `uniform4iv` in class `PGL`

    - #### uniform1fv

          public void uniform1fv(int location,
                                 int count,
                                 FloatBuffer v)

      Specified by:
        `uniform1fv` in class `PGL`

    - #### uniform2fv

          public void uniform2fv(int location,
                                 int count,
                                 FloatBuffer v)

      Specified by:
        `uniform2fv` in class `PGL`

    - #### uniform3fv

          public void uniform3fv(int location,
                                 int count,
                                 FloatBuffer v)

      Specified by:
        `uniform3fv` in class `PGL`

    - #### uniform4fv

          public void uniform4fv(int location,
                                 int count,
                                 FloatBuffer v)

      Specified by:
        `uniform4fv` in class `PGL`

    - #### uniformMatrix2fv

          public void uniformMatrix2fv(int location,
                                       int count,
                                       boolean transpose,
                                       FloatBuffer mat)

      Specified by:
        `uniformMatrix2fv` in class `PGL`

    - #### uniformMatrix3fv

          public void uniformMatrix3fv(int location,
                                       int count,
                                       boolean transpose,
                                       FloatBuffer mat)

      Specified by:
        `uniformMatrix3fv` in class `PGL`

    - #### uniformMatrix4fv

          public void uniformMatrix4fv(int location,
                                       int count,
                                       boolean transpose,
                                       FloatBuffer mat)

      Specified by:
        `uniformMatrix4fv` in class `PGL`

    - #### validateProgram

          public void validateProgram(int program)

      Specified by:
        `validateProgram` in class `PGL`

    - #### isShader

          public boolean isShader(int shader)

      Specified by:
        `isShader` in class `PGL`

    - #### getShaderiv

          public void getShaderiv(int shader,
                                  int pname,
                                  IntBuffer params)

      Specified by:
        `getShaderiv` in class `PGL`

    - #### getAttachedShaders

          public void getAttachedShaders(int program,
                                         int maxCount,
                                         IntBuffer count,
                                         IntBuffer shaders)

      Specified by:
        `getAttachedShaders` in class `PGL`

    - #### getShaderInfoLog

          public String getShaderInfoLog(int shader)

      Specified by:
        `getShaderInfoLog` in class `PGL`

    - #### getShaderSource

          public String getShaderSource(int shader)

      Specified by:
        `getShaderSource` in class `PGL`

    - #### getShaderPrecisionFormat

          public void getShaderPrecisionFormat(int shaderType,
                                               int precisionType,
                                               IntBuffer range,
                                               IntBuffer precision)

      Specified by:
        `getShaderPrecisionFormat` in class `PGL`

    - #### getVertexAttribfv

          public void getVertexAttribfv(int index,
                                        int pname,
                                        FloatBuffer params)

      Specified by:
        `getVertexAttribfv` in class `PGL`

    - #### getVertexAttribiv

          public void getVertexAttribiv(int index,
                                        int pname,
                                        IntBuffer params)

      Specified by:
        `getVertexAttribiv` in class `PGL`

    - #### getVertexAttribPointerv

          public void getVertexAttribPointerv(int index,
                                              int pname,
                                              ByteBuffer data)

      Specified by:
        `getVertexAttribPointerv` in class `PGL`

    - #### getUniformfv

          public void getUniformfv(int program,
                                   int location,
                                   FloatBuffer params)

      Specified by:
        `getUniformfv` in class `PGL`

    - #### getUniformiv

          public void getUniformiv(int program,
                                   int location,
                                   IntBuffer params)

      Specified by:
        `getUniformiv` in class `PGL`

    - #### isProgram

          public boolean isProgram(int program)

      Specified by:
        `isProgram` in class `PGL`

    - #### getProgramiv

          public void getProgramiv(int program,
                                   int pname,
                                   IntBuffer params)

      Specified by:
        `getProgramiv` in class `PGL`

    - #### getProgramInfoLog

          public String getProgramInfoLog(int program)

      Specified by:
        `getProgramInfoLog` in class `PGL`

    - #### scissor

          public void scissor(int x,
                              int y,
                              int w,
                              int h)

      Specified by:
        `scissor` in class `PGL`

    - #### sampleCoverage

          public void sampleCoverage(float value,
                                     boolean invert)

      Specified by:
        `sampleCoverage` in class `PGL`

    - #### stencilFunc

          public void stencilFunc(int func,
                                  int ref,
                                  int mask)

      Specified by:
        `stencilFunc` in class `PGL`

    - #### stencilFuncSeparate

          public void stencilFuncSeparate(int face,
                                          int func,
                                          int ref,
                                          int mask)

      Specified by:
        `stencilFuncSeparate` in class `PGL`

    - #### stencilOp

          public void stencilOp(int sfail,
                                int dpfail,
                                int dppass)

      Specified by:
        `stencilOp` in class `PGL`

    - #### stencilOpSeparate

          public void stencilOpSeparate(int face,
                                        int sfail,
                                        int dpfail,
                                        int dppass)

      Specified by:
        `stencilOpSeparate` in class `PGL`

    - #### depthFunc

          public void depthFunc(int func)

      Specified by:
        `depthFunc` in class `PGL`

    - #### blendEquation

          public void blendEquation(int mode)

      Specified by:
        `blendEquation` in class `PGL`

    - #### blendEquationSeparate

          public void blendEquationSeparate(int modeRGB,
                                            int modeAlpha)

      Specified by:
        `blendEquationSeparate` in class `PGL`

    - #### blendFunc

          public void blendFunc(int src,
                                int dst)

      Specified by:
        `blendFunc` in class `PGL`

    - #### blendFuncSeparate

          public void blendFuncSeparate(int srcRGB,
                                        int dstRGB,
                                        int srcAlpha,
                                        int dstAlpha)

      Specified by:
        `blendFuncSeparate` in class `PGL`

    - #### blendColor

          public void blendColor(float red,
                                 float green,
                                 float blue,
                                 float alpha)

      Specified by:
        `blendColor` in class `PGL`

    - #### alphaFunc

          public void alphaFunc(int func,
                                float ref)

      Specified by:
        `alphaFunc` in class `PGL`

    - #### colorMask

          public void colorMask(boolean r,
                                boolean g,
                                boolean b,
                                boolean a)

      Specified by:
        `colorMask` in class `PGL`

    - #### depthMask

          public void depthMask(boolean mask)

      Specified by:
        `depthMask` in class `PGL`

    - #### stencilMask

          public void stencilMask(int mask)

      Specified by:
        `stencilMask` in class `PGL`

    - #### stencilMaskSeparate

          public void stencilMaskSeparate(int face,
                                          int mask)

      Specified by:
        `stencilMaskSeparate` in class `PGL`

    - #### clear

          public void clear(int buf)

      Specified by:
        `clear` in class `PGL`

    - #### clearColor

          public void clearColor(float r,
                                 float g,
                                 float b,
                                 float a)

      Specified by:
        `clearColor` in class `PGL`

    - #### clearDepth

          public void clearDepth(float d)

      Specified by:
        `clearDepth` in class `PGL`

    - #### clearStencil

          public void clearStencil(int s)

      Specified by:
        `clearStencil` in class `PGL`

    - #### deleteFramebuffers

          public void deleteFramebuffers(int n,
                                         IntBuffer framebuffers)

      Specified by:
        `deleteFramebuffers` in class `PGL`

    - #### genFramebuffers

          public void genFramebuffers(int n,
                                      IntBuffer framebuffers)

      Specified by:
        `genFramebuffers` in class `PGL`

    - #### bindRenderbuffer

          public void bindRenderbuffer(int target,
                                       int renderbuffer)

      Specified by:
        `bindRenderbuffer` in class `PGL`

    - #### deleteRenderbuffers

          public void deleteRenderbuffers(int n,
                                          IntBuffer renderbuffers)

      Specified by:
        `deleteRenderbuffers` in class `PGL`

    - #### genRenderbuffers

          public void genRenderbuffers(int n,
                                       IntBuffer renderbuffers)

      Specified by:
        `genRenderbuffers` in class `PGL`

    - #### renderbufferStorage

          public void renderbufferStorage(int target,
                                          int internalFormat,
                                          int width,
                                          int height)

      Specified by:
        `renderbufferStorage` in class `PGL`

    - #### framebufferRenderbuffer

          public void framebufferRenderbuffer(int target,
                                              int attachment,
                                              int rendbuferfTarget,
                                              int renderbuffer)

      Specified by:
        `framebufferRenderbuffer` in class `PGL`

    - #### framebufferTexture2D

          public void framebufferTexture2D(int target,
                                           int attachment,
                                           int texTarget,
                                           int texture,
                                           int level)

      Specified by:
        `framebufferTexture2D` in class `PGL`

    - #### checkFramebufferStatus

          public int checkFramebufferStatus(int target)

      Specified by:
        `checkFramebufferStatus` in class `PGL`

    - #### isFramebuffer

          public boolean isFramebuffer(int framebuffer)

      Specified by:
        `isFramebuffer` in class `PGL`

    - #### getFramebufferAttachmentParameteriv

          public void getFramebufferAttachmentParameteriv(int target,
                                                          int attachment,
                                                          int pname,
                                                          IntBuffer params)

      Specified by:
        `getFramebufferAttachmentParameteriv` in class `PGL`

    - #### isRenderbuffer

          public boolean isRenderbuffer(int renderbuffer)

      Specified by:
        `isRenderbuffer` in class `PGL`

    - #### getRenderbufferParameteriv

          public void getRenderbufferParameteriv(int target,
                                                 int pname,
                                                 IntBuffer params)

      Specified by:
        `getRenderbufferParameteriv` in class `PGL`

    - #### blitFramebuffer

          public void blitFramebuffer(int srcX0,
                                      int srcY0,
                                      int srcX1,
                                      int srcY1,
                                      int dstX0,
                                      int dstY0,
                                      int dstX1,
                                      int dstY1,
                                      int mask,
                                      int filter)

      Specified by:
        `blitFramebuffer` in class `PGL`

    - #### renderbufferStorageMultisample

          public void renderbufferStorageMultisample(int target,
                                                     int samples,
                                                     int format,
                                                     int width,
                                                     int height)

      Specified by:
        `renderbufferStorageMultisample` in class `PGL`

    - #### readBuffer

          public void readBuffer(int buf)

      Specified by:
        `readBuffer` in class `PGL`

    - #### drawBuffer

          public void drawBuffer(int buf)

      Specified by:
        `drawBuffer` in class `PGL`